# $Id: Locale.pm,v 1.1.1.1 2006/12/17 09:35:21 koba Exp $
#	Copyright(c) 2006 Satoshi Kobayashi, All rights reserved.

package XiuMai::Locale;

use strict;
use XiuMai::Msg;
use vars qw($VERSION);

$VERSION = do { my @r = (q$Revision: 1.1.1.1 $ =~ /\d+/g);
				sprintf("%d." . "%02d" x $#r, @r) };

my %locale;
my $default_filename;

sub init {
	$default_filename = shift;
	undef %locale;
}

sub _get_default {
	return $locale{_default}	if (exists $locale{_default});
	my $msg = new XiuMai::Msg($default_filename)
										or die "$default_filename: $!";
	return $locale{_default} = $msg;
}

sub get {
	my (@lang) = @_;
	foreach my $lang (@lang) {
		$lang = lc($lang);
		return wantarray ? ($locale{$lang}, $lang) : $locale{$lang}
												if (exists $locale{$lang});
		my $msg = new XiuMai::Msg("$default_filename.$lang");
		next if (! defined $msg);
		$locale{$lang} = $msg;
		return wantarray ? ($msg, $lang) : $msg;
	}
	return wantarray ? (_get_default) : _get_default;
}

1;
