# $Id: XiuMai.pm,v 1.9 2011/12/14 15:23:47 koba Exp $
#	Copyright(c) 2006-2011 Satoshi Kobayashi, All rights reserved.

package XiuMai::Resource::XiuMai;

use strict;
use XiuMai::Resource::Text;
use XiuMai::XHTML::Text;
use XiuMai::Text;
use XiuMai::Util qw(cdata);
use FileHandle;
use vars qw($VERSION @ISA);

$VERSION = $XiuMai::VERSION;

@ISA = qw(XiuMai::Resource::Text);

sub _html {
	my $self = shift;

	my $text = new XiuMai::Text($self);
	$self->{html_body} = $text->parse;

	my $html = new XiuMai::XHTML::Text($self);
	$self->{html}
		= $html->title($text->title)
			   ->lang($text->lang)
			   ->stylesheet($text->stylesheet)
			   ->icon($text->icon)
			   ->style($text->style)
			   ->as_string($self->{html_body});

	$self->{type}  = undef;
	$self->{size}  = length($self->{html});
	$self->{mtime} = undef;
	$self->{lang}  = [$html->content_language];

	return $self;
}

sub html_body {
	my $self = shift;
	return $self->{html_body};
}

sub update {
	my $self = shift;
	$self->SUPER::update	or return;
	$self->{redirect_url}  = $self->url			if (-f $self->{path});
	return $self;
}

1;
